<script lang="ts">
import Vue from 'vue';
import VideoModal from '~/components/solutions/video-modal.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'DibHero',
  components: {
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <section class="dib-hero">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="5" size="md">
          <SlpTypography
            variant="heading5-bold"
            tag="h2"
            class="sp-mb-8 subtext"
            >{{ data.subtext }}</SlpTypography
          >
          <SlpTypography variant="heading1-bold" tag="h1" class="slp-mb-24">{{
            data.header
          }}</SlpTypography>
          <div class="list">
            <ul>
              <li
                v-for="item in data.list"
                :key="item.text"
                class="list__item slp-mb-16"
              >
                <SlpIcon
                  variant="marketing"
                  size="md"
                  name="check-circle-alt"
                  class="check-icon"
                />
                <SlpTypography tag="span" variant="heading5">
                  {{ item.text }}
                </SlpTypography>
              </li>
            </ul>
          </div>
          <SlpTypography tag="div" variant="heading5-bold">
            <span class="body" v-html="$md.render(data.body)" />
          </SlpTypography>
          <SlpButton
            v-if="data.cta.url"
            class="slp-mt-32 dib-hero__button"
            variant="primary"
            :data-ga-name="data.cta.data_ga_name"
            :data-ga-location="data.cta.data_ga_location"
            :href="data.cta.url"
            >{{ data.cta.text }}
            <SlpIcon icon="gl-download" class="slp-ml-8" />
          </SlpButton>
        </SlpColumn>
        <SlpColumn :cols="7" class="dib-hero__img-col" size="md">
          <div
            v-if="data.video_link"
            class="video-wrapper"
            @click="openModal()"
          >
            <SlpIcon
              class="play-icon"
              name="play-circle"
              variant="marketing"
              size="lg"
            />
            <img
              id="video-container__image"
              preload
              class="thumbnail-image"
              :src="data.video_thumbnail"
              alt=""
            />
          </div>

          <VideoModal
            v-if="data.video_link"
            v-show="showModal && data.video_link"
            light-background
            :visible="showModal"
            @close="showModal = false"
          >
            <template #body>
              <lite-vimeo
                :videoid="getVimeoVideoId(createVideoSource(data.video_link))"
                autoplay
              ></lite-vimeo>
            </template>
          </VideoModal>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.dib-hero {
  padding: $spacing-96 0;
  position: relative;
  z-index: 1;

  @media (min-width: $breakpoint-lg) and (max-width: $breakpoint-xl) {
    padding: 96px 24px;
  }

  @media (min-width: $breakpoint-md) and (max-width: $breakpoint-lg) {
    padding: $spacing-48 0 $spacing-96 0;
  }

  .subtext {
    -webkit-text-fill-color: transparent;
    background: linear-gradient(
      91.08deg,
      #f9a026 -9.03%,
      #a686f2 27.88%,
      #592ac8 65.98%
    );

    background-clip: text;
  }

  .list {
    &__item {
      display: flex;
      flex-direction: row;
      gap: 16px;
      padding-left: 16px;
      align-items: center;
    }
  }

  &__img-col {
    display: flex;
    justify-content: right;
    position: relative;

    @media (max-width: $breakpoint-lg) {
      flex: 0 1 100%;
    }
  }
  &__img {
    position: relative;
    z-index: 1;
    margin-top: $spacing-48;
    width: 100%;
    max-height: 590px;
    object-fit: contain;
    @media (min-width: $breakpoint-md) {
      margin-top: 0;
    }
    @media (min-width: $breakpoint-lg) {
      width: auto;
    }
  }
  &__button {
    @media (max-width: $breakpoint-md) {
      width: 100%;
      text-align: center;
      justify-content: center;
    }
  }

  .video-wrapper {
    margin: 0 0 0 64px;
    cursor: pointer;
    position: relative;
    flex: 1 1 100%;
    max-height: 456px;
    max-width: 594px;
    width: 35vw;
    border-radius: 8px 8px 160px 8px;
    display: flex;
    align-items: center;

    @media (max-width: $breakpoint-md) {
      margin: 24px 0 0 0;
      width: 100%;
      max-width: 100%;
      border-radius: 4px 4px 40px 4px;
    }

    .play-icon {
      color: $color-text-link-100;
      cursor: pointer;
      font-size: 48px;
      left: 50%;
      position: absolute;
      top: 50%;
      transform: translate(-50%, -50%);
      z-index: 2;
    }

    img {
      object-fit: cover;
      width: 100%;
      display: block;
      border-radius: 8px 8px 160px 8px;
      border: 1px solid $color-surface-300;
      @media (max-width: $breakpoint-md) {
        border-radius: 4px 4px 40px 4px;
      }
    }
  }
}
</style>
